SystemOrganization addCategory: #ConfigurationOfLauritzThamsen!

Object subclass: #ConfigurationOfLauritzThamsen
	instanceVariableNames: 'project selected'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfLauritzThamsen'!

ConfigurationOfLauritzThamsen class
	instanceVariableNames: 'accessMap'!

!ConfigurationOfLauritzThamsen commentStamp: 'lt 7/19/2012 16:06' prior: 0!
ConfigurationOfLauritzThamsen is a fork of ConfigurationOfTimFelgentreff-tfel.11 (http://ss3.gemstone.com/ss/timfelgentreff.html).!

ConfigurationOfLauritzThamsen class
	instanceVariableNames: 'accessMap'!

!ConfigurationOfLauritzThamsen class methodsFor: 'accessing' stamp: 'lt 7/31/2012 16:44:21.96'!
accessMap

	| userNames password |
	accessMap ifNotNil: [^ accessMap].
	userNames := Dictionary newFrom: {'ss3' -> 'lauritzthamsen'. 'hirschfeld' -> 'lauritz.thamsen'. 'squeaksource' -> 'LT'}.
	password := UIManager default requestPassword: 'Password for repositories'.
	accessMap := Dictionary new.
	#('ss3' 'hirschfeld' 'squeaksource') do: [:squeaksource |
		accessMap
			at: squeaksource
			put: (userNames at: squeaksource) -> password].
	^ accessMap! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'tfel 2/22/2012 15:57:01.078'!
allWindowsDo: aBlock

	SystemWindow subclasses
		collect: [:k | k allInstances]
		thenDo: [:iary | iary do: aBlock].! !

!ConfigurationOfLauritzThamsen class methodsFor: 'private' stamp: 'tfel 2/2/2012 11:12'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 7/31/2012 16:55:59.555'!
cleanImage

	self hideWindows.
	
	Smalltalk garbageCollect.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 7/31/2012 16:56:40.169'!
configureEnvironment

	self 
		configureTools;
		setAuthorInitials.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 8/1/2012 15:38'!
configureTools

	World color: Preferences defaultWorldColor.
	TextEditor autoEnclose: true.
	MCConfiguration extraProgressInfo: true.
	SystemWindow
		hideExpandButton: true;
		reuseWindows: true! !

!ConfigurationOfLauritzThamsen class methodsFor: 'private' stamp: 'tfel 2/2/2012 11:12'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfLauritzThamsen class methodsFor: 'private' stamp: 'tfel 2/2/2012 11:12'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 7/31/2012 16:49:19.282'!
hideWindows

	self allWindowsDo: [ :window | window hide ].! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 7/31/2012 19:36:10.922'!
initialWorkspaceContents

	^ 
'(Installer mc http: ''http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/'') 
	project: ''MetacelloRepository'';
	install: ''ConfigurationOfSightDynamic''.
(Smalltalk at: #ConfigurationOfSightDynamic) loadBleedingEdge.
	
(Smalltalk at: #UiWorldToolbar) open.'! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 8/1/2012 13:03:16.121'!
install

	self
		installProjects;
		setPreferences;
		configureEnvironment;
		cleanImage;
		openInitialWorkspace.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 8/1/2012 15:55'!
installProjects

	| groups instance mm |
	instance := self new.
	groups := instance project bleedingEdge groups collect: [:group | group name].
	mm := MenuMorph new
		stayUp: true;
		target: instance;
		yourself.
	groups do: [:name |
		mm addUpdating: ('IsSelected', name) asSymbol action: ('ToggleSelect', name) asSymbol].
	mm
		addLine;
		add: 'Install'
		target: [
			mm abandon.
			instance selected ifNotEmpty: [.
				instance project bleedingEdge load: instance selected asArray.]]
		selector: #value
		argumentList: #().
	mm
		center: ActiveHand center;
		openInWorld.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'metacello tool support' stamp: 'tfel 2/2/2012 11:12'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 7/31/2012 19:02'!
openInitialWorkspace

	(Workspace new contents: self initialWorkspaceContents) 
		openLabel: 'Vivide Development'.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'accessing' stamp: 'tfel 2/2/2012 11:12'!
project

	^self new project! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 7/31/2012 16:58:00.902'!
setAuthorInitials

	Utilities 
		setAuthorInitials: 'lt';
		authorName: 'lauritzthamsen'.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'lt 7/31/2012 16:54:05.217'!
setPreferences

	Preferences
		enable: #showDeprecationWarnings;
		enable: #swapMouseButtons;
		enable: #infiniteUndo;
		enable: #multipleTextUndo;
		enable: #higherPerformance;
		enable: #annotationPanes;
		disable: #fastDragWindowForMorphic;
		enable: #mercuryPanel;
		disable: #showSharedFlaps.! !

!ConfigurationOfLauritzThamsen class methodsFor: 'actions' stamp: 'tfel 2/22/2012 15:56:43.091'!
showWindows

	self allWindowsDo: [:window | window show].! !

!ConfigurationOfLauritzThamsen class methodsFor: 'development support' stamp: 'tfel 2/2/2012 11:12'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfLauritzThamsen methodsFor: 'private' stamp: 'tfel 4/11/2012 13:49'!
accessAssociationFor: aUrl

	^ (self accessMap associations
		detect: [:assoc | (aUrl includesSubString: assoc key)]
		ifNone: ['' -> ('' -> '')]) value! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'tfel 4/17/2012 16:33:16.125'!
accessMap
	"Answer the value of accessMap"

	^ self class accessMap! !

!ConfigurationOfLauritzThamsen methodsFor: 'private' stamp: 'tfel 4/11/2012 13:47'!
addProjects: aListOfSpecs to: spec inVersion: versionString

	aListOfSpecs do: [:array || name url deps configs projects | "groupname [url] [deps] [configs]"
			name := array first.
			url := (array at: 2 ifAbsent: []) ifNil: ['http://www.squeaksource.com/MetacelloRepository'].
			deps := (array at: 3 ifAbsent: []) ifNil: [#()].
			configs := (array at: 4 ifAbsent: []) ifNil: [{name. #('default')}].
			projects := deps asOrderedCollection.
			
			configs pairsDo: [:projectname :loads |
				projects add: 'Project', projectname.
				spec project: projects last with: [
					spec
						className: 'ConfigurationOf', projectname;
						file: 'ConfigurationOf', projectname;
						repository: url
						username: (self usernameFor: url)
						password: (self passwordFor: url);
						loads: loads;
						versionString: versionString]].
			spec group: name with: projects].! !

!ConfigurationOfLauritzThamsen methodsFor: 'baselines' stamp: 'lt 8/1/2012 16:18:29.615'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/lauritzthamsen'.
		self
			addProjects: self bleedingEdgeProjects to: spec inVersion: #bleedingEdge;
			addProjects: self developmentProjects to: spec inVersion: #development;
			addProjects: self stableProjects to: spec inVersion: #stable.
			
		self specificProjectsWithVersions keysAndValuesDo: [ :project :version | 
			self addProjects: {project} to: spec inVersion: version]].
! !

!ConfigurationOfLauritzThamsen methodsFor: 'specs' stamp: 'lt 8/1/2012 16:05:49.849'!
bleedingEdgeProjects 
	"groupname [url] [deps] [configs]"
 	^ #(
	)
! !

!ConfigurationOfLauritzThamsen methodsFor: 'specs' stamp: 'lt 8/1/2012 16:04:01.407'!
developmentProjects 
	"groupname [url] [deps] [configs]"
 	^ #(
		#('SwaLint' 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository')
		#('Signals' 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository')
		#('SwaOmniBrowser' 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository')
		#('Designer' 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository')
		#('SightDynamic' 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository')
	)! !

!ConfigurationOfLauritzThamsen methodsFor: 'error handling' stamp: 'tfel 2/2/2012 14:07'!
doesNotUnderstand: aMessage

	(aMessage selector asString beginsWith: 'IsSelected') ifTrue: [| name |
		name := (aMessage selector asString copyReplaceAll: 'IsSelected' with: '').
		^ self packageIsSelected: name].
	(aMessage selector asString beginsWith: 'ToggleSelect') ifTrue: [| name |
		name := (aMessage selector asString copyReplaceAll: 'ToggleSelect' with: '').
		^ self togglePackage: name].

	^ super doesNotUnderstand: aMessage! !

!ConfigurationOfLauritzThamsen methodsFor: 'initialize-release' stamp: 'tfel 4/17/2012 16:32:19.913'!
initialize

	super initialize.
	self selected: OrderedCollection new.! !

!ConfigurationOfLauritzThamsen methodsFor: 'actions' stamp: 'tfel 2/2/2012 14:06'!
packageIsSelected: name

	^ ((self selected includes: name)
			ifTrue: ['<yes>']
			ifFalse: ['<no>']), name! !

!ConfigurationOfLauritzThamsen methodsFor: 'private' stamp: 'tfel 4/11/2012 13:48'!
passwordFor: aUrl

	^ (self accessAssociationFor: aUrl) value! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'tfel 2/2/2012 11:12'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'tfel 2/2/2012 14:08'!
project: anObject
	"Set the value of project"

	project := anObject! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'tfel 2/2/2012 14:08'!
selected
	"Answer the value of selected"

	^ selected! !

!ConfigurationOfLauritzThamsen methodsFor: 'accessing' stamp: 'tfel 2/2/2012 14:08'!
selected: anObject
	"Set the value of selected"

	selected := anObject! !

!ConfigurationOfLauritzThamsen methodsFor: 'baselines' stamp: 'lt 8/1/2012 16:17:02.639'!
specificProjectsWithVersions

	^ Dictionary newFrom: {
		#('OmniBrowser') -> '1.2.2'
	}! !

!ConfigurationOfLauritzThamsen methodsFor: 'specs' stamp: 'lt 8/1/2012 16:03:45.751'!
stableProjects 
	"groupname [url] [deps] [configs]"
 	^ #(
			#('MetacelloBrowser' 'http://www.squeaksource.com/MetacelloBrowser/')
			#('Seaside' nil #('OmniBrowser') #('Seaside30' #() 'Magritte2' #('Magritte-Seaside')))
	)! !

!ConfigurationOfLauritzThamsen methodsFor: 'actions' stamp: 'tfel 2/2/2012 14:18'!
togglePackage: name

	^ (self selected includes: name)
			ifTrue: [self selected remove: name]
			ifFalse: [self selected add: name]! !

!ConfigurationOfLauritzThamsen methodsFor: 'private' stamp: 'tfel 4/11/2012 13:48'!
usernameFor: aUrl

	^ (self accessAssociationFor: aUrl) key! !
